package com.fp.frontend.controller.pgeneral.gene;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.PostConstruct;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;

import org.primefaces.event.SelectEvent;

import com.fp.dto.Request;
import com.fp.dto.Response;
import com.fp.dto.query.DtoQuery;
import com.fp.dto.save.DtoSave;
import com.fp.frontend.controller.AbstractController;
import com.fp.frontend.controller.pgeneral.lov.BalanceTypeLovController;
import com.fp.frontend.controller.pgeneral.product.ProductController;
import com.fp.frontend.controller.pgeneral.product.SubProductController;
import com.fp.frontend.helper.MessageHelper;
import com.fp.persistence.pgeneral.charge.TgeneSubProductCharges;
import com.fp.persistence.pgeneral.gene.TgeneBalanceType;
import com.fp.persistence.pgeneral.product.TgeneProduct;
import com.fp.persistence.pgeneral.product.TgeneSubProduct;

/**
 * Clase controladora del bean TgeneSubProductCharges.
 *
 * @author Jorge Vaca.
 * @version 2.1
 */
@SuppressWarnings("serial")
@ManagedBean
@ViewScoped
public class SubProductChargesController extends AbstractController<TgeneSubProductCharges> {

    public SubProductChargesController() throws Exception {
        super(TgeneSubProductCharges.class);
    }

    @PostConstruct
    private void postconstruct() {
        this.init();
        // Inicializa autoconsulta
        super.startQuery();

    }

    /**
     * Incializa el controlador, cuando se esta utilizando una pagina que utliza
     * el controlador.
     */
    private void init() {
        try {
            this.recperpage = 15; // Cambiar al # reg a mirar.
            this.lrecord = new ArrayList<>();
            this.beanalias = "SUBPRODUCTCHARGES";
        } catch (Exception e) {
            MessageHelper.setMessageError(e);
        }
    }

    /**
     * Crea una instancia de TgeneTransactionProcess y marca el registro como
     * nuevo.
     *
     * @throws Exception
     */
    @Override
    public void create() throws Exception {
        if (!this.validaterequired()) {
            return;
        }
        super.create();
        this.record.getPk().setModulecode(super.getMfilters().get("pk.modulecode"));
        this.record.getPk().setCompanycode(super.getLoginController().getRequest().getCompany());
        this.record.getPk().setProductcode(super.getMfilters().get("pk.productcode"));
        this.record.getPk().setSubproductcode(super.getMfilters().get("pk.subproductcode"));
    }

    @SuppressWarnings("unchecked")
    @Override
    protected void querydatabase() {
        try {
            if (!this.validaterequired()) {
                return;
            }
            Request request = this.callerhelper.getRequest();
            //super.addFilter("pk.modulecode", super.getMfilelds().get("modulecode").toString());			
            super.addFilter("pk.companycode", super.getLoginController().getRequest().getCompany().toString());
            DtoQuery dto = super.getDtoQuery(true);
            dto.setOrderby("t.pk.balancetype, t.pk.balancegroup"); // En en string van todos los campos de orden ("t.pk,  t.nombre, t.cpais").

            HashMap<String, DtoQuery> mtables = new HashMap<String, DtoQuery>();
            mtables.put(this.beanalias, dto); // permite adicionar mas de una tabla.

            request.setQueryTables(mtables);

            Response resp = this.callerhelper.executeQuery(request);

            if (resp.getResponseCode().compareTo(Response.RESPONSE_OK) != 0) {
                this.lrecord = new ArrayList<TgeneSubProductCharges>();
                MessageHelper.setMessageError(resp);
            } else {
                this.lrecord = (List<TgeneSubProductCharges>) resp.get(this.beanalias);
                super.postQuery(this.lrecord);
            }

        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
        }
    }

    @Override
    public void save() {
        try {
            Request request = this.callerhelper.getRequest();
            DtoSave dtosave = super.getDtoSave();
            if (!dtosave.pendingProcess()) {
                return;
            }
            HashMap<String, DtoSave> msave = new HashMap<String, DtoSave>();
            msave.put(this.beanalias, dtosave); // adicionar metadata de mantenimiento para cada tabla.

            request.setSaveTables(msave);
            Response resp = this.callerhelper.executeSave(request);
            if (resp.getResponseCode().compareTo(Response.RESPONSE_OK) == 0) {
                this.postCommit(resp);
                MessageHelper.setMessageInfo(resp);
            } else {
                MessageHelper.setMessageError(resp);
            }

        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
        }
    }

    @Override
    public void postCommit(Response response) throws Exception {
        super.postCommitGeneric(response, this.beanalias);
    }

    /**
     * Valida filtros
     *
     * @return
     * @throws Exception
     */
    private boolean validaterequired() throws Exception {
        if (super.getMfilters().get("pk.modulecode") == null) {
            MessageHelper.setMessageError("msg_modulerequird");
            return false;
        }
        if (super.getMfilters().get("pk.productcode") == null) {
            MessageHelper.setMessageError("msg_productrequird");
            return false;
        }
        if (super.getMfilters().get("pk.subproductcode") == null) {
            MessageHelper.setMessageError("msg_subproductrequird");
            return false;
        }
        return true;
    }

}
